//window.addEventListener("load", function(event){ CustomGeometryInitialize(); }, false);
self.setTimeout('CustomGeometryInitialize();', 2000);


function ResizeScreen()
{
	var Width=1192, Height=1170, Left=728, Top=0;
	var oPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

	if(oPrefs.prefHasUserValue("customgeometry.options.width"))
		Width = oPrefs.getIntPref("customgeometry.options.width");
	if(oPrefs.prefHasUserValue("customgeometry.options.height"))
		Height = oPrefs.getIntPref("customgeometry.options.height");
	if(oPrefs.prefHasUserValue("customgeometry.options.left"))
		Left = oPrefs.getIntPref("customgeometry.options.left");
	if(oPrefs.prefHasUserValue("customgeometry.options.top"))
		Top = oPrefs.getIntPref("customgeometry.options.top");
	
	SetGeometry(Width, Height, Left, Top);
}

function CustomGeometryInitialize()
{
	var oPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

	UpdateMenu();
	
/*	//  Auto run on startup?
	if(oPrefs.prefHasUserValue("customgeometry.options.runatstartup"))
		if (oPrefs.getIntPref("customgeometry.options.runatstartup") != 0)
		{
			ResizeScreen();
		}*/
}


//  Update the list of sizes.
function UpdateMenu()
{
	try{
		//Prefs
		var oPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
		var GeometryStore = '';
		var ContextMenu;
		var GeometrySplit;
		var GeometryArray;
		var GeometryIndex;
		var Name;
		var Width;
		var Height;
		var Left;
		var Top;
		var OneOption;
		
		SelectedIndex = -1;
		
		//Prefill
		if(oPrefs.prefHasUserValue("customgeometry.options.list"))
			GeometryStore = oPrefs.getCharPref("customgeometry.options.list");
		
		if (GeometryStore == '')
			GeometryStore = "Default^1192^1170^728^0";
		
		GeometrySplit = GeometryStore.split('~');
		ContextMenu = document.getElementById("Customgeometry-context");
		
		//  Clear the menu.
		while (ContextMenu.hasChildNodes())
		{
			ContextMenu.removeChild(ContextMenu.childNodes[0]);
		}
		
		OneOption = document.createElement("menuitem");
		OneOption.setAttribute('label', 'Show Current Geometry');
		OneOption.setAttribute('oncommand', 'ShowCurrentGeometry();');
		ContextMenu.appendChild(OneOption);
		
		for (GeometryIndex=0; GeometryIndex<GeometrySplit.length; GeometryIndex++)
		{
			GeometryArray = GeometrySplit[GeometryIndex].split('^');
			Name = GeometryArray[0];
			Width = GeometryArray[1];
			Height = GeometryArray[2];
			Left = GeometryArray[3];
			Top = GeometryArray[4];
			
			OneOption = document.createElement("menuitem");
			OneOption.setAttribute('label', 'Set: ' + Name);
			OneOption.setAttribute('oncommand', 'SetGeometry(' + Width + ', ' + Height + ', ' + Left + ', ' + Top + ');');
			ContextMenu.appendChild(OneOption);
			
			if (Name == 'Default')
			{
				SetGeometry(Width, Height, Left, Top);
			}
		}
	}catch(err){ alert(err); }
}


function ShowCurrentGeometry()
{
	alert("Current Geometry\n\nWidth: " + window.outerWidth + "\nHeight: " + window.outerHeight + "\nLeft: " + window.screen.availLeft + "\nTop: " + window.screen.availTop);
}


function SetGeometry(Width, Height, Left, Top)
{
	window.moveTo(Left, Top);
	window.resizeTo(Width, Height);
	//alert(window.outerWidth + 'x' + window.outerHeight + '+' + window.screen.availLeft + '+' + window.screen.availTop);
}

